/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
 
//#################################################
// Useful functions
//#################################################
function wget(url, callback, callbackArgs)
{
  try
  {
    var request = new XMLHttpRequest();
    
    request.open('GET', url, true); //TODO: Add a parameter behind the URL to avoid cache effects
    request.onreadystatechange = function()
    {
      if(request.readyState == 4)
      {
        if(request.status==200)
        {
          var response = null;
          
          try
          {
            response = JSON.parse(request.responseText);
          }
          catch(exc)
          {}
        
          callback(
          response, 
          callbackArgs);
        }
        else if(request.status==0)
        {
          callback(null,callbackArgs);
        }
      }
    };

    request.send(null);
      
  }
  catch(exc)
  {}
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
var CK_EXT_PARAMETERS = new Object(); 

CK_EXT_PARAMETERS.TRACKING_MODE = "EXTERNAL"; //"EXTERNAL";           // INTERNAL or EXTERNAL


CK_EXT_PARAMETERS.SITE_BASE_URL = "http://www.capitalkoala.com";


CK_EXT_PARAMETERS.SIGNUP_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/" ;
CK_EXT_PARAMETERS.PASSWORD_LOST_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/connexion/" ;
CK_EXT_PARAMETERS.LAST_PURCHASES = CK_EXT_PARAMETERS.SITE_BASE_URL + "/compte/achats-remboursements/" ;
CK_EXT_PARAMETERS.MY_ACCOUNT = CK_EXT_PARAMETERS.SITE_BASE_URL + "/compte/" ;
CK_EXT_PARAMETERS.EDIT_FAVORITE_MERCHANT_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/compte/commercants-favoris/" ;
CK_EXT_PARAMETERS.SEARCH_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/commercants/recherche/" ;
CK_EXT_PARAMETERS.HELP_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/faq/" ;


//CK_EXT_PARAMETERS.PROGRAMS_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/api/program/" ;
//CK_EXT_PARAMETERS.LOGIN_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/api/auth/login/" ;
//CK_EXT_PARAMETERS.LOGOUT_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/api/auth/logout/" ;
//CK_EXT_PARAMETERS.LOGGEDIN_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/api/auth/status/" ;
//CK_EXT_PARAMETERS.CATEGORIES_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/api/category/" ;
//CK_EXT_PARAMETERS.AFTER_INSTALL_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/info/toolbar/" ;
//CK_EXT_PARAMETERS.AFTER_UNINSTALL_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/info/uninstall/" ;
//CK_EXT_PARAMETERS.VERSION_URL = CK_EXT_PARAMETERS.SITE_BASE_URL + "/api/toolbar/firefox/" ;


/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/

/////////////////////////////////////////////////
/////////////////////////////////////////////////
/////////////////////////////////////////////////
// TODO: REMOVE
/////////////////////////////////////////////////
/////////////////////////////////////////////////
/////////////////////////////////////////////////

/**
 * safari__TabIdManager
 * @constructor
 */
function safari__TabIdManager()
{
	var _that			= this;

	_that._tabs			= new Array();

	_that.getTabId 		= function(tab)
	{
		var tabFound    = false;
		var id          = 0;

		for(var i=0; (i<_that._tabs.length)&&(!tabFound); i++)
		{
			if(_that._tabs[i] == tab)
			{
				tabFound = true;
				id = i;
			}
		}

		if(!tabFound)
		{
			_that._tabs.push(tab);
			id = _that._tabs.length - 1;
		}

		return (id + 1);
	};

	_that.getTabFromId   = function(id)
	{
		var i = id - 1;

		return (i < _that._tabs.length)?_that._tabs[i]:null;
	};
}

/**
 * safari__Navigator
 * @constructor
 */
function safari__Navigator()
{
	var _that								= this;

	/** @private */ _that.tabIdManager      = new safari__TabIdManager();

	_that.sendRequestToTab   = function(tabId, request)
	{
		_that.tabIdManager.getTabFromId(tabId)['page']['dispatchMessage'](request['action'], (request['args'])?request['args']:null);
	};

	_that.sendRequestToActiveTab   = function(request)
	{
		safari['application']['activeBrowserWindow']['activeTab']['page']['dispatchMessage'](request['action'], (request['args'])?request['args']:null);
	};

	_that.sendRequestToAllTabs   = function(request)
	{
		for(var i = 0; i<_that.tabIdManager._tabs.length; i++)
		{
			_that.tabIdManager._tabs[i]['page']['dispatchMessage'](request['action'], (request['args'])?request['args']:null);
		}
	};

	_that.sendRequestToBackground   = function(request)
	{
		try
		{
			safari['self']['tab']['dispatchMessage'](request['action'], (request['args'])?request['args']:null);
		}
		catch(exc)
		{

		}
	};

	_that.getLocalURL              = function(url)
	{
		return safari['extension']['baseURI'] + url;
	};
}

//FIXME: navigator shouldn't be allowed outside of that file
var __deprecated__navigator = new safari__Navigator();

/////////////////////////////////////////////////
/////////////////////////////////////////////////
/////////////////////////////////////////////////


 function navigatorAbstractionLayerObject()
 {
 	var _that 							= this;

	///////////////////////////////////////////////////////////
 	// Safari
 	///////////////////////////////////////////////////////////
 	_that.__callbackPile 				= {},

 	_that.__dispatchCallbacks 			= function(event)
 	{
 		if(_that.__callbackPile[event['name']])
 		{
 			_that.__callbackPile[event['name']](event['message']);
 			delete _that.__callbackPile[event['name']]; 
 		}
 	};

 	_that.notifyConnectionStateChange 	= function()
 	{
 		__deprecated__navigator.sendRequestToAllTabs({'action':'connection_status_changed', 'args':{}}); 
      	__deprecated__navigator.sendRequestToActiveTab({'action':'actualize_popup', 'args':{}});
 	};

 	_that.openPopup  					= function(popupName, width, height, errorOn, callback, bypassTosFix)
 	{
 		///////////////////////////////
 		// Quick fix for TOS
 		///////////////////////////////
 		if((popupName == "tos")&&(bypassTosFix==null))
 		{
 			//Actualize active tab before sending the shit
 			safari['application']['activeBrowserWindow']['activeTab']['url'] = safari['application']['activeBrowserWindow']['activeTab']['url']; 
 			setTimeout
 			(
 				function()
 				{
 					_that.openPopup(popupName, width, height, errorOn, callback, true);
 				},
 				1000
 			);
 			return;
 		}
 		///////////////////////////////

		var request =
		{
			'action':     "open_"+popupName+"_popup",
			'args':
			{
				'errorOn':     errorOn
			}
		};


		__deprecated__navigator.sendRequestToActiveTab(request);
		
		//We don't use callback
 	};

        _that.openReferrerPopup = function(message,u_f_name, callback)
 	{

		var request =
		{
			'action':     "open_refwarning_popup",
			'args':    
                            {   
                                'message' : message,
                                'u_f_name': u_f_name
                            }
		};


		__deprecated__navigator.sendRequestToActiveTab(request);
		
		
 	};
        
 	_that.openPromoPopup 				= function(extensionObject, domainId, errorOn, callback)
 	{
 		extensionObject.getDomainInfo
		(
			function(domainInfo)
			{
				var request =
				{
					'action':     "open_promo_popup",

					'args':
					{
						'domainInfo':     domainInfo
					}
				};

				__deprecated__navigator.sendRequestToActiveTab(request);
			},

			domainId
		);
 	};

 	_that.openConfigPopup 				= function(extensionObject, errorOn, callback)
 	{
 		extensionObject.getConfig
		(
			function(config)
			{
				var request =
				{
					'action':     "open_config_popup",

					'args':       config
				};

				__deprecated__navigator.sendRequestToActiveTab(request);
			}
		);
 	};

 	_that.hidePopupWithId 				= function(popupId, callback)
 	{
 		//Do nothing
 	};

 	_that.reactToVersionExpiration 		= function(newVersionNumber)
 	{
	    //If remote version number is higher than local version number, ask user if he wants to download new version
	    //If not, dsplay a popup
	    var version_request =
	    {
	      'action':     "open_version_popup",

	      'args':
	      {
	      }
	    };

	    __deprecated__navigator.sendRequestToActiveTab(version_request);

	    //localStorage["CK_version"] = newVersionNumber;
 	};

 	_that.getMenuNodeDefaultIcon 		= function()
 	{
 		return "defaultIcon";
 	};

 	_that.sendRequestToTab 				= function(tabId, request)
 	{
 		__deprecated__navigator.sendRequestToTab(tabId, request);
 	};

 	_that.sendRequestToBackground 		= function(request)
 	{
 		__deprecated__navigator.sendRequestToBackground(request);
 	};

 	_that.sendRequestToBackgroundWithCallback 	= function(request, callback)
 	{
 		if((request)&&(request['action']))
 		{
 			var guid 									= _that.generateGuid();
 			var actionWithGuid 							= request['action'] + "/" + guid;
 			var callbackWithGuid						= request['action'] + "_callback/" + guid;

 			_that.__callbackPile[callbackWithGuid]  	= callback;

 			var request2								= request;
 			request2['action'] 							= actionWithGuid;

 			_that.sendRequestToBackground(request2);
 		}
 	};

 	_that.getLocalURL 					= function(url)
 	{
 		return __deprecated__navigator.getLocalURL(url);
 	};

 	_that.openUrlInNewTab 				= function(domainId,url)
 	{
 		__deprecated__navigator.sendRequestToBackground({'action':'safari__open_tab', 'args':{'url':url,'domainId':domainId}});
 	};

        _that.openNewTab 			= function(url)
 	{
                window.top.location.href=url;
                var newTab  	= safari['application']['activeBrowserWindow']['activeTab'];
		newTab['url']  	= url;     
 		//__deprecated__navigator.sendRequestToBackground({'action':'safari__goto', 'args':{'url':url}});
 	};
        
 	_that.openUrlInActiveTab 			= function(url)
 	{
                window.top.location.href=url;
                var newTab  	= safari['application']['activeBrowserWindow']['activeTab'];
		newTab['url']  	= url;     
 		//__deprecated__navigator.sendRequestToBackground({'action':'safari__goto', 'args':{'url':url}});
 	};

 	_that.hidePopupMenuIfNecessary 		= function()
 	{
 		__deprecated__navigator.sendRequestToBackground({'action':"safari__hide_popup",'args':{}});
 	};

 	_that.popup 						=
 	{
 		positionTitleInValue: function(titleInValue)
 		{
 			titleInValue['style']['float'] = "right";
 		}
 	};

 	_that.addBackgroundListener 		= function(callback)
 	{
 		safari['self']['addEventListener']
 		(
 			"message", 
 			function(event)
 			{
 				var request = 
 				{
 					'action':event['name'],
 					'args':((event['message'])?event['message']:null)
 				};

 				callback(request);
 			},
 			false
 		);
 	};

 	_that.pokeURL 						= function(url)
	{
		wget(url, function(args){}, null);
	};

	_that.generateGuid 					= function()
	{
		//From: http://stackoverflow.com/questions/105034/how-to-create-a-guid-uuid-in-javascript
		var S4 = function() {
		return (((1+Math.random())*0x10000)|0).toString(16).substring(1);
		};
		return (S4()+S4()+"-"+S4()+"-"+S4()+"-"+S4()+"-"+S4()+S4()+S4());
	};

	_that.getToolbarGuid 				= function(callback)
	{
		_that.sendRequestToBackgroundWithCallback
		(
			{
				"action": 				"get_toolbar_guid",
				"args": 				{}
			},
			callback
		);
	};

	_that.getUrlOfTab 					= function(tabId, callback)
	{
		callback(__deprecated__navigator.tabIdManager.getTabFromId(tabId)['url']);
	};

 	//Add listener for callbacks management
 	if((safari['self']) && (safari['self']['addEventListener'])) //We are in an injected script
 	{
 		safari['self']['addEventListener']("message", _that.__dispatchCallbacks, false);
 	}
 	else if((safari['application']) && (safari['application']['addEventListener'])) //We are in background page
 	{
 		safari['application']['addEventListener']("message", _that.__dispatchCallbacks, false);
 	}
 }

 var navigatorAbstractionLayer = new navigatorAbstractionLayerObject();
/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
/**
 * Database
 * @constructor
 * @param {string} fetchUrl
 * @param {int} ttl
 */
function Database(fetchUrl,fetchUrl2,ttl) 
{
  var _that               = this;

  _that.fetchUrl           = fetchUrl;
  _that.fetchUrl2           = fetchUrl2;  
  _that.ttl                = ttl;

  _that['_d']              =
  {
    "domains":              {},
    "nodomains":              {},
    "sites":                {},
    "programs":             {} 
    //,
//    domainMap:            {}
  };
  
  _that['_d2']              =
  {
    "referrers_list":              {},
    "default_messages":                {}
  };  

  _that._lastFetchDate     = 0;
  _that._request           = null;

//--------------------------------------------------------------
//--------------------------------------------------------------
  _that._storeData         = function(data)
  {
    if
    (
        (data)
      &&(data['domains'])
      &&(data['sites'])
      &&(data['programs'])
      &&(typeof(data)=="object")
      &&(typeof(data['domains'])=="object")
      &&(typeof(data['sites'])=="object")
      &&(typeof(data['programs'])=="object")
    )
    { 
      //Adding domainId to each program for easier manipulation
      for(var program in data['programs'])
      {
      	for(var site in data['sites'])
      	{
      		for(var i=0; i<data['sites'][site]['urls'].length; i++)
      		{
      			if(data['sites'][site]['urls'][i]==program)
      			{
      				data['programs'][program]['domainId'] = site;
      			}
      		}
      	}
      }
    
	_that['_d']            = data; 
       for (var t in _that['_d']['domains'])
        {
            if (t.indexOf("(")==0)
            {
                var ind=t.indexOf(")");
                var subrexp=t.substring(1,ind);
                var realdom=t.substring(ind+2);
                var tab=subrexp.split("|");
                for (var i=0;i<tab.length;i++)
                {
                    _that['_d']['nodomains'][tab[i]+"."+realdom]=1;
                }
                var saved=_that['_d']['domains'][t];
                delete _that['_d']['domains'][t];
                _that['_d']['domains'][realdom]=saved;
            }
        }          
    
      _that._lastFetchDate   = Math.round(new Date().getTime() / 1000); 
    }
  };
//--------------------------------------------------------------
  _that.fetch              = function(callback, args)
  {
    try
    {
      _that._request.abort();
    }
    catch(exc)
    {}

    _that._request = new XMLHttpRequest();

    _that._request.open('GET', _that.fetchUrl, true); //TODO: Add a parameter behind the URL to avoid cache effects

    _that._request.onreadystatechange = function()
    {
      if (_that._request.readyState == 4)
      {
        if (_that._request.status == 200)
        {
          try
          {
            var data = JSON.parse(_that._request.responseText);
            data['nodomains']={};
            _that._storeData(data);

            //callback(args);
          }
          catch(err)
          {
            //Do nothing
          } 
        }
        else
        {}
      }
    };

    _that._request.send();
    
    
    _that._request2 = new XMLHttpRequest();

    _that._request2.open('GET', _that.fetchUrl2, true); //TODO: Add a parameter behind the URL to avoid cache effects

    _that._request2.onreadystatechange = function()
    {
      if (_that._request2.readyState == 4)
      {
        if (_that._request2.status == 200)
        {
          try
          {
            var data2 = JSON.parse(_that._request2.responseText);

	  _that['_d2']            = data2; 

            callback(args);
          }
          catch(err)
          {
            //Do nothing
          } 
        }
        else
        {}
      }
    };

    _that._request2.send();    
  };
//--------------------------------------------------------------
  _that.update           = function(callback, args)
  {
  

    var currentTime = Math.round(new Date().getTime() / 1000);

    if(currentTime > (_that._lastFetchDate + parseInt(_that.ttl)))
    {
      _that.fetch(callback, args);
    }
    else
    {
      callback(args);
    }
  };
//--------------------------------------------------------------
  _that.getDomainInfo               = function(domain)
  {
    var info = new Object();

    var _domain = _that['_d']['domains'][domain];
    if(_domain)
    {
      var _site = _that['_d']['sites'][_domain];
      if(_site)
      {
        info['domain']     = domain;
        info['title']      = _site['title'];
        info['text']      = _site['text'];        
        info['codes']      = _site['codes'];      
        info['specials']   = _site['specials'];
        info['urls']       = new Array();
        
        for(var i=0; i < _site['urls'].length; i++)
        {
          if(_that['_d']['programs'][_site['urls'][i]])
          {
            info['urls'].push(_that['_d']['programs'][_site['urls'][i]]['url']);
          }
        }
      }
    }
    
    return info;
  }
//--------------------------------------------------------------
//--------------------------------------------------------------
  _that.getDomainInfoById          = function(domainId, callback, args)
  {
    _that.update
    (
      function(args)
      {    
            var currentSiteID = null ;
            var currentSite = null ;
            var hostname=null;


            var re = new RegExp('^(?:f|ht)tp(?:s)?\://([^/]+)(/[^/]*)?', 'im');
            if (args['callbackArgs']['w']==undefined)
                m=domainId.match(re);
            else
                m=args['callbackArgs']['w']['url'].match(re);
            if (m!=null && m[1]!=undefined && m[2]!=undefined)
                hostname=m[1].toString()+m[2].toString();
            else if (m!=null && m[1]!=undefined)
                hostname=m[1].toString();
            else
                hostname="";
            
                t=hostname;  
            if (_that['_d']['nodomains'][hostname]== undefined)
            {    
                while (true)
                {            
                        var site_id= _that['_d']['domains'][t];
                        if (site_id != undefined)
                        {
                                currentSite = _that['_d']['sites'][site_id] ;
                                currentSiteID = site_id ;

                                break ;
                        }
                        if (t.indexOf(".") > -1)
                                t = t.substr(t.indexOf(".")+1) ;
                        else
                                break;
                }
            }
                        if (currentSiteID==null)
                        {
                       
                            var ind=hostname.indexOf("/");
                            if (ind!=-1)
                            {
                                hostname=hostname.substring(0,ind);
                                if (_that['_d']['nodomains'][hostname]== undefined)
                                {
                                    var t =  hostname;
                                    while (true)
                                    {
                                            var site_id = _that['_d']['domains'][t];
                                            if (site_id != undefined)
                                            {
                                                    currentSite = _that['_d']['sites'][site_id] ;
                                                    currentSiteID = site_id ;

                                                    break ;
                                            }
                                            if (t.indexOf(".") > -1)
                                                    t = t.substr(t.indexOf(".")+1) ;
                                            else
                                                    break;
                                    }
                                }
                            }
                        }
      
      
        var _site = currentSite;
          
        if(_site)
        {
        
          program_ids = _site["urls"];
          pid = program_ids[0] ;
          program =_that['_d']['programs'][pid];
         

   
          var info = new Object();
        
          info['url_friendly_name']=CK_EXT_PARAMETERS.SITE_BASE_URL+"/redirection/marchand/"+program["url_friendly_name"] + '?toolbar=1';          
          
          info['title']      = _site['title'];
          info['codes']      = _site['codes'];        
          info['text']      = _site['text'];             
          info['specials']   = _site['specials'];
          info['urls']       = new Array();
            
          for(var i=0; i < _site['urls'].length; i++)
          {
            if(_that['_d']['programs'][_site['urls'][i]])
            {
              info['urls'].push(_that['_d']['programs'][_site['urls'][i]]['url']);
            }
          }
          
          //Return info (only if not empty)
          args['callback'](info, args['callbackArgs']);
        }
      },
      
      {
        '_this':           _that,
        'domainId':        domainId,
        'callback':        callback,
        'callbackArgs':    args
      }
    );
  }
  
//--------------------------------------------------------------    
  _that.ifDomainIsConcerned        = function(domain, callback, callbackArgs)
  {
    _that.update
    (
      function(args)
      {     
       console.log("Nodomains array  :" + _that['_d']['nodomains'][args['domain']]); 
        if (_that['_d']['nodomains'][args['domain']]== undefined)
        {
        //We don't get the full domain names from the server
        //So.. Let's do regular expressions
          var domainsFound = new Array();
        
          for(var domain in _that['_d']['domains'])
          {
              //We put in a table all domain names which could correspond to our target domain
              var exp = new RegExp(domain + "$", "g");
              
              if(exp.test(args['domain']))
              {
                domainsFound.push(domain);
              }
          }
               console.log("Domain loop done  " ); 
        //If we found corresponding domain names, we continue
        if(domainsFound.length > 0)
        {
          console.log("Domain found  " ); 
          // One our more domains were found.
          // We prepare to callback.
          var domainFound = "";

          // If several domains correspond to our host, we focus on the longest one  
          if(domainsFound.length > 1)
          {
            for(var i=0; i<domainsFound.length; i++)
            {
              if(domainsFound[i].length > domainFound.length)
              {
                domainFound = domainsFound[i];
              }
            }
          }
          else
          {
            domainFound = domainsFound[0];
          }
          console.log("Domain is  " +domainFound); 
          // Let's return the information attached to the domain
          var domainId = _that['_d']['domains'][domainFound];
            console.log("Domainid is  " +domainId); 
          args['callback'](domainId, args['callbackArgs']);
        }
       }
      },
    
      {
        '_this':          _that,
        'domain':         domain,
        'callback':       callback,
        'callbackArgs':   callbackArgs
      }
    )
  };
//--------------------------------------------------------------
//--------------------------------------------------------------
  _that.fetch(function(){}, null);
}

/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
/**
 * ConfigManager
 * @constructor
 */
function ConfigManager()
{
	var _that			= this;

	_that._config		=
	{
		'acceptedTos':  				false,
		'urlsLinkToNewTab':				true,
		'login':						false,
		'password':						false,
		'activatedDomains':				"",
		'ttl':                  		30,
		'toolbarGUID': 					""			
	};
	
	_that.getConfig		= function()
	{
		return _that._config;
	};
	
	_that.setConfig		= function(config)
	{
		for(var conf in config)
		{
			if(_that._config[conf] != "undefined")
			{
				_that._config[conf]	= config[conf];
				//_that.saveConfig(conf);
			}
		}

		_that.saveConfig(conf);
	};
	
	_that.saveConfig		= function(setting)
	{
		/*
		if(!setting)
		{
			for(var conf in _that._config)
			{
				localStorage[conf]	= _that._config[conf];
			}
		}
		else
		{
			localStorage[setting]	= _that._config[setting];
		}
		*/

		try
		{
			localStorage["com.eNoe.capital-koala.config"] = JSON.stringify(_that._config);
		}
		catch(err)
		{
			//Do nothing
		}
	};
	
	_that._restoreConfig	= function()
	{
		if((localStorage)&&(localStorage["com.eNoe.capital-koala.config"]))
		{
			try
			{
				_that._config = JSON.parse(localStorage["com.eNoe.capital-koala.config"]);
			}
			catch(err)
			{
				//Do nothing
			}
		}
		/**
		for(var conf in _that._config)
		{
			if(localStorage[conf])
			{
				_that._config[conf]	= localStorage[conf];
			}
		}
		**/
	};
	
	_that._restoreConfig();
}

/**
 * EventManager
 * @constructor
 */

function EventManager(parent)
{
	var _that					= this;
	_that._parent 				= parent;

	_that.sendEvent 			= function(name, parameters)
	{
		var e = 
		{
			"name": 				name,
			"event-guid": 			navigatorAbstractionLayer.generateGuid(),
			"toolbar-guid":			_that._parent.getToolbarGUID(),
			"toolbar-version": 		"3.0.0.6",
			"timestamp" : 			(new Date()).getTime(),
			"parameters": 			parameters
		};

		var serializedEvent = JSON.stringify(e);
		var eventURL = "http://www.capitalkoala.com/project/public/media/toolbars/capitalkoala/sf/safari/events/push/?e="+urlencode(serializedEvent);
		
		try
		{
			navigatorAbstractionLayer.pokeURL(eventURL);
		}
		catch(err)
		{
			//Do nothing
		}
	};

	_that.sendRawTrackingActivationEvent			= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("RAW_TRACKING_ACTIVATION", parameters);
	};

	_that.sendToolbarTrackingLinkClickedEvent 		= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("TOOLBAR_TRACKING_LINK_CLICKED", parameters);
	};

	_that.sendOpenProgramUrlEvent 					= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("PROGRAM_URL_OPENED", parameters);
	};

	_that.sendTrackingAutoActivatedEvent 			= function(userId, siteId, url)
	{
		var parameters = 
		{
			"userId": 				userId,
			"siteId": 				siteId,
			"url": 					url
		};

		_that.sendEvent("TRACKING_AUTO_ACTIVATED", parameters);
	};
}

function urlencode (str) {
    // http://kevin.vanzonneveld.net
    // +   original by: Philip Peterson
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: AJ
    // +   improved by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +      input by: travc
    // +      input by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Kevin van Zonneveld (http://kevin.vanzonneveld.net)
    // +   improved by: Lars Fischer
    // +      input by: Ratheous
    // +      reimplemented by: Brett Zamir (http://brett-zamir.me)
    // +   bugfixed by: Joris
    // +      reimplemented by: Brett Zamir (http://brett-zamir.me)
    // %          note 1: This reflects PHP 5.3/6.0+ behavior
    // %        note 2: Please be aware that this function expects to encode into UTF-8 encoded strings, as found on
    // %        note 2: pages served as UTF-8
    // *     example 1: urlencode('Kevin van Zonneveld!');
    // *     returns 1: 'Kevin+van+Zonneveld%21'
    // *     example 2: urlencode('http://kevin.vanzonneveld.net/');
    // *     returns 2: 'http%3A%2F%2Fkevin.vanzonneveld.net%2F'
    // *     example 3: urlencode('http://www.google.nl/search?q=php.js&ie=utf-8&oe=utf-8&aq=t&rls=com.ubuntu:en-US:unofficial&client=firefox-a');
    // *     returns 3: 'http%3A%2F%2Fwww.google.nl%2Fsearch%3Fq%3Dphp.js%26ie%3Dutf-8%26oe%3Dutf-8%26aq%3Dt%26rls%3Dcom.ubuntu%3Aen-US%3Aunofficial%26client%3Dfirefox-a'

    str = (str+'').toString();
    
    // Tilde should be allowed unescaped in future versions of PHP (as reflected below), but if you want to reflect current
    // PHP behavior, you would need to add ".replace(/~/g, '%7E');" to the following.
    return encodeURIComponent(str).replace(/!/g, '%21').replace(/'/g, '%27').replace(/\(/g, '%28').
                                                                    replace(/\)/g, '%29').replace(/\*/g, '%2A').replace(/%20/g, '+');
}


/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
function SessionManager(ttl, onConnect, onConnectArgs, onDisconnect, onDisconnectArgs)
{
  var _that                  = this;

  _that.ttl                  = ttl;
  _that._lastFetchDate       = 0;
  _that._userInfo            = null;
  _that.onConnectArgs        = onConnectArgs;
  _that.onConnect            = onConnect;
  _that.onDisconnectArgs     = onDisconnectArgs;
  _that.onDisconnect         = onDisconnect;
//--------------------------------------------------------------
//--------------------------------------------------------------
  _that.disconnect       = function()
  {
    if(_that._userInfo)
    {
      wget
      (
        "http://www.capitalkoala.com/api/auth/logout/",
        
        function(response, _this)
        {
          _that.onDisconnect(_that._userInfo, _that.onDisconnectArgs);
          _that._userInfo = null;
        },
        
        _that
      );
    }
  };
//--------------------------------------------------------------
  _that.connect          = function(login, password, callback, callbackArgs)
  {
    _that.disconnect();

  
    wget
    (
      "http://www.capitalkoala.com/api/auth/login/?login=" + urlencode(login) + "&password=" + urlencode(password),
      
      function(response, args)
      {
        if((response)&&(response['id']))
        {
          _that._userInfo = response;
          
          _that.onConnect(_that._userInfo, _that.onConnectArgs);
          args['callback'](true, args['callbackArgs']);
        }
        else
        {
          args['callback'](false, args['callbackArgs']);
        }
      },
      
      {
        '_this':          _that,
        'callback':       callback,
        'callbackArgs':   callbackArgs
      }
    );
  };
//--------------------------------------------------------------
  _that.isUserConnected      = function(callback, args)
  {
    //Get the time to check the ttl
    var currentTime = Math.round(new Date().getTime() / 1000);

    if(currentTime > (_that._lastFetchDate + _that.ttl))
    {
      _that._lastFetchDate = currentTime;
      
      //If the ttl is expired, perform a server request
      wget
      (
        "http://www.capitalkoala.com/api/auth/status/",
        
        function(response, _this)
        {
          if((response)&&(response['id']))
          {
            _that._userInfo = response;         
            
            callback(true, args);
          }
          else
          {
            _that.disconnect();
            callback(false, args);
          }
        },
        
        _that
      );
    }
    else
    {
      //Else, check internally
      callback((!(!_that._userInfo)), args);
    }
   
  };
//--------------------------------------------------------------
  _that.getUserId        = function()
  {
    var id = 0;
    
    if(_that._userInfo)
    {
      id = _that._userInfo.id;
    }
    
    return id;
  };
//--------------------------------------------------------------
  _that.getUserInfo      = function()
  {
    return _that._userInfo;
  };
//--------------------------------------------------------------
//--------------------------------------------------------------
}

/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
		 /**
		 * CategoryMenuServer
		 * @constructor
		 * @param {string} fetchUrlCategories
		 * @param {string} fetchUrlPrograms
		 * @param {int} updatePeriod
		 */
		function CategoryMenuServer(fetchUrlCategories, fetchUrlPrograms, updatePeriod)
		{
			var _that						= this;

			_that.fetchUrlCategories		= fetchUrlCategories;
			_that.fetchUrlPrograms			= fetchUrlPrograms;
			_that.updatePeriod				= updatePeriod;
			_that._data						= null;
			_that.timer              		= null;
			_that._userId					= 0;
			
//--------------------------------------------------------------
//--------------------------------------------------------------
			_that._getUrl					= function(url)
			{
				var reg=new RegExp("(%id%)", "g");
          
         		return url.replace(reg,"" + _that._userId);
			};
//--------------------------------------------------------------
			_that.getData					= function()
			{
				return _that._data;
			};
//--------------------------------------------------------------
			
			_that._buidDataNode				= function(categoryId, categoriesIndex, ProgramsIndex)
			{
				var data		= new Object();
				
				data['icon']		= categoriesIndex[categoryId]['icon'];
				data['title']		= categoriesIndex[categoryId]['name'];
				
				if(categoriesIndex[categoryId]['style'])
				{
					data['style']	= categoriesIndex[categoryId]['style'];
				}
				else
				{
					data['style']	= new Object();
				}
				
				//Put subcategeries in blue
				if(categoryId == "root")
				{
					for(var i=0; i<categoriesIndex[categoryId]['category_ids'].length; i++)
					{
					  if(!categoriesIndex[categoriesIndex[categoryId]['category_ids'][i]]['style'])
					  {
					    categoriesIndex[categoriesIndex[categoryId]['category_ids'][i]]['style']		= new Object();
					  }
					  categoriesIndex[categoriesIndex[categoryId]['category_ids'][i]]['style']['color'] = "black";
					}
				}

				if((categoriesIndex[categoryId]['program_ids']) && (!data['style']['color']))
				{
					data['style']['color'] = "rgb(0,91,168)";
				}
				
				
				data['children']	= new Array();
				
				for(var i=0; i<categoriesIndex[categoryId]['category_ids'].length; i++)
				{
					data['children'].push(_that._buidDataNode(categoriesIndex[categoryId]['category_ids'][i], categoriesIndex, ProgramsIndex));
				}
				
				var defaultIcon = navigatorAbstractionLayer.getMenuNodeDefaultIcon(); 
				
				if(categoriesIndex[categoryId]['program_ids'])
				{
					var children        = new Object();
					var childrenTitles  = new Array();
          
					for(var i=0; i<categoriesIndex[categoryId]['program_ids'].length; i++)
					{
						var program 		= new Object();
					
						program['title'] 	= ProgramsIndex[categoriesIndex[categoryId]['program_ids'][i]]['title'];
						program['icon']		= ProgramsIndex[categoriesIndex[categoryId]['program_ids'][i]]['icon'];
						
						if(program['icon'] == "")
						{
							program['icon']	= defaultIcon;
						}
						
						
                                                program['url']		= CK_EXT_PARAMETERS.SITE_BASE_URL+"/redirection/marchand/"+ProgramsIndex[categoriesIndex[categoryId]['program_ids'][i]]['url_friendly_name'] + '?toolbar=1'; 
						
						//Manage domain pre-activation
						program['domainId']	= ProgramsIndex[categoriesIndex[categoryId]['program_ids'][i]]['domainId'];
				
						children[program['title'].toUpperCase()]    = program;
						childrenTitles.push(program['title'].toUpperCase());
					}
					
					childrenTitles.sort();
					
					for(var i=0; i<childrenTitles.length; i++)
					{
            			data['children'].push(children[childrenTitles[i]]);
					}
				}
				
				return data;
			};
//--------------------------------------------------------------			
			_that._generateInternalData		= function(categoriesIndex, ProgramsIndex, SitesIndex)
			{
				//For pre-activation: add a domainId entry to each program entry
				for(var site in SitesIndex)
				{
					for(var j=0; j<SitesIndex[site]['urls'].length; j++)
					{
						ProgramsIndex[SitesIndex[site]['urls'][j]]['domainId']	= site; 
					}
				}
				
				//Add program_ids to the category objects listed in the categoriesIndex	
				for(var program in ProgramsIndex)
				{
					for(var i=0; i<ProgramsIndex[program]['category_ids'].length; i++)
					{
						if(!categoriesIndex[ProgramsIndex[program]['category_ids'][i]]['program_ids'])
						{
							categoriesIndex[ProgramsIndex[program]['category_ids'][i]]['program_ids'] = new Array();
						}
						
						categoriesIndex[ProgramsIndex[program]['category_ids'][i]]['program_ids'].push(program);
					}
				}
				
				//Add style customizations
				categoriesIndex["selection"]['style'] = 
				{
					'fontWeight':		"bold"
				};
				
				//Build a clean tree structure from that data
				_that._data = _that._buidDataNode("root", categoriesIndex, ProgramsIndex);
				
				//Save data for next unconnected uses
				localStorage["config_manager_data"] = JSON.stringify(_that._data);		
			};
//--------------------------------------------------------------	
			//Refresh the content of the menu with updated data
			_that.update						= function()
			{
				//1. Get the category hierarchy
				wget
				(
					_that.fetchUrlCategories,
					
					function(response, args)
					{
						
						if((response) && (typeof(response) == "object"))
						{
							//2. Get the programs
							wget
							(
								_that.fetchUrlPrograms,
								
								function(response2, args2)
								{
									
									if(response2 && response2['programs'])
									{
										//3. Reinitialize internal data with the content fetched
										_that._generateInternalData(args2['categories'], response2['programs'], response2['sites']);
									
										//4. Refresh the DOM object
										//_that._processData();
									}
								},
								
								{
									'_this':		_that,
									'categories':	response
								}
							);
						}
					},
					
					{
						'_this':	_that
					}
				);
			};
//--------------------------------------------------------------
			_that.setUserId					= function(userId)
			{
				_that._userId 				= userId;
				_that.update();
			};
//--------------------------------------------------------------
			_that.setUpdatePeriod    	= function(updatePeriod)
			{
				_that.updatePeriod 		= updatePeriod;

				clearInterval(_that.timer);

				_that.timer				= setInterval
				(
				  function()
				  {
				    _that.update();
				  },
				  
				  (_that.updatePeriod * 1000)
				);	

			};
//--------------------------------------------------------------
//--------------------------------------------------------------
			
			//Generate the DOM object
			if(localStorage["config_manager_data"])
			{
				try
				{
					_that._data        = JSON.parse(localStorage["config_manager_data"]);
				}
				catch(exc)
				{
					_that.update();
				}
			}
			else
			{
				_that.update();
			}
			
			//Set a timer to refresh the menu periodically
			 _that.setUpdatePeriod(_that.updatePeriod);
		}
/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
 /**
 * ToolbarManager
 * @constructor
 * @param {WindowManager} windowManager
 * @param {TrackingManager} trackingManager
 * @param {Database} database
 */
function ToolbarManager(windowManager, trackingManager, database, configManager, eventManager)
{
  var _that               = this;

  _that._windowManager    = windowManager;
  _that._trackingManager  = trackingManager;
  _that._database         = database;
  _that._configManager    = configManager;
  _that._eventManager     = eventManager;
//-------------------------------------------------------------- 
//--------------------------------------------------------------  
  _that._activateWindow     = function(w) 
  {
    ////////////////////////////////////////////////////////
    // Cancel acton if no TOS acceptance
    ////////////////////////////////////////////////////////
    if(_that._configManager.getConfig()['acceptedTos'] === false)
    {
      return;
    }
    ////////////////////////////////////////////////////////

    w['toolbarState']['activated']  = true;
    w['callback']({'action':'activate_toolbar'});    

    //////////////////////////////////////
    // EVENT TRACKING
    //////////////////////////////////////
    navigatorAbstractionLayer.getUrlOfTab
    (
      w['id'],
      function(url)
      {
        _that._eventManager.sendRawTrackingActivationEvent
        (
          _that._trackingManager.getTrackingId(), 
          w['domainId'],
          url
        );
      }
    );
    //////////////////////////////////////
  };
//--------------------------------------------------------------  
  _that._desactivateWindow     = function(w) 
  {
    ////////////////////////////////////////////////////////
    // Cancel acton if no TOS acceptance
    ////////////////////////////////////////////////////////
    if(_that._configManager.getConfig()['acceptedTos'] === false)
    {
      return;
    }
    ////////////////////////////////////////////////////////
    
    w['toolbarState']['activated']  = false;
    w['callback']({'action':'desactivate_toolbar'});    
  };
  
  _that._referBlockWindow     = function(w,message) 
  {
    ////////////////////////////////////////////////////////
    w['toolbarState']['activated']  = false;
    w['callback']({'action':'refer_block_toolbar','message':message});    
  };  
//--------------------------------------------------------------  
  _that.activateDomain     = function(domainId)
  {
    var ws = _that._windowManager.getWindowsByDomainId(domainId);
    
    if((ws)&&(ws[0]))
    {
      for(var i=0; i < ws.length; i++)
      {
        _that._activateWindow(ws[i]);
      }
    }
  }

  _that.desactivateDomain     = function(domainId)
  {
    var ws = _that._windowManager.getWindowsByDomainId(domainId);
    
    if((ws)&&(ws[0]))
    {
      for(var i=0; i < ws.length; i++)
      {
        _that._desactivateWindow(ws[i]);
      }
    }
  }
  
  _that['referBlockDomain']     = function(domainId,message)
  {

    var ws = _that._windowManager.getWindowsByDomainId(domainId);
    if((ws)&&(ws[0]))
    {
      for(var i=0; i < ws.length; i++)
      {
        _that._referBlockWindow(ws[i],message);
      }
    }
  }  

  _that.desactivateAll       = function()
  {
    var ws = _that._windowManager.getAllWindows();
    
    if((ws)&&(ws[0]))
    {
      for(var i=0; i < ws.length; i++)
      {
        _that._desactivateWindow(ws[i]);
      }
    }
  }
//--------------------------------------------------------------  
  _that.initWindow         = function(windowId,referrer_result)
  {
    ////////////////////////////////////////////////////////
    // Cancel acton if no TOS acceptance
    ////////////////////////////////////////////////////////
    if(_that._configManager.getConfig()['acceptedTos'] === false)
    {
      return;
    }
    ////////////////////////////////////////////////////////
    
    var w = _that._windowManager.getWindowById(windowId);

    if(w)
    {

      //Init the toolbar object
      w['toolbarState']                 = new Object();
      w['toolbarState']['activated']    = (referrer_result['block']==undefined && _that._trackingManager.isDomainActive(w['domainId'])) || (referrer_result['block']!=undefined && !referrer_result['block']['block'])  ;
      w['toolbarState']['_displayed']   = true;
      w['toolbarState']['isReferrerBlock']   = referrer_result['block']!=undefined?referrer_result['block']['block']:false;   
      w['toolbarState']['referrerMessage']   = referrer_result['block']!=undefined?referrer_result['block']['message']:"";    
      
      
      _that._database.getDomainInfoById
      (
        w['url'],
        
        function(info, args)
        {
          var w = args['w'];
          
          w['toolbarState']['_barText'] 			 = info['title'];
          w['toolbarState']['_promoDisplayed']	= (info['codes'].length>0);
          
          //Display the toolbar on the remote window
          w['callback']({'action':'display_toolbar', 'args':{'toolbarState':w['toolbarState']}});  
        },

        {
          'w':        w
        }
      );  
    } 
    return w;
  };
//--------------------------------------------------------------  
  _that.isWindowActive         = function(windowId)
  {
    var w = _that._windowManager.getWindowById(windowId);

    if(w)
    {
      if(_that._trackingManager.isDomainActive(w['domainId']))
      {
         w['callback']({'action':'activate_toolbar', 'args':{'toolbarState':w['toolbarState']}}); 

        //////////////////////////////////////
        // EVENT TRACKING
        //////////////////////////////////////
        navigatorAbstractionLayer.getUrlOfTab
        (
          w['id'],
          function(url)
          {
            _that._eventManager.sendRawTrackingActivationEvent
            (
              _that._trackingManager.getTrackingId(), 
              w['domainId'],
              url
            );
          }
        );
        //////////////////////////////////////
      }
      else
      {
        w['callback']({'action':'desactivate_toolbar', 'args':{'toolbarState':w['toolbarState']}}); 
      }
    } 
  };
}

/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/

/**
 * TrackingManager
 * @constructor
 * @param {WindowManager} windowManager
 * @param {Database} database
 * @param {ConfigManager} configManager
 * @param {int} updatePeriod
 */
function TrackingManager(windowManager, database, configManager, updatePeriod)
{
  var _that                       = this;

  _that._windowManager            = windowManager;
  _that._domainMap                = new Object();
  _that._database                 = database;
  _that._configManager            = configManager;
  _that._trackingId               = 0;
  _that.updatePeriod              = updatePeriod;
  _that.timer                     = null;
  _that._windowsBeingActivated    = {};
  _that._windowsToRedirect        = {};
//-------------------------------------------------------------- 
//-------------------------------------------------------------- 
  _that._activateWindow     = function(w)
  {   
      var req               = new Object();
      
      req['action']         = 'activate_tracking';
      req['tabId']          = w['id'];
      req['args']           = new Object();
      
      if(_that._domainMap[w['domainId']]['trackingUrls'].length > 0)
      {        
          req['args']['trackingUrls'] = _that._domainMap[w['domainId']]['trackingUrls'];
          w['callback'](req);
          
          ////////
          _that._windowsBeingActivated[w['id']] = w['domainId'];
          ////////
      }
      else
      {
        //Get the tracking URLs if nobody fetched them before
        _that._database.getDomainInfoById
        (
          w['domainId'],
        
          function(info, args)
          {
            var w     = args['w'];
            
            //Now we've got the tracking URL, let's replace the %id% tag in them
            var urls=new Array();
            urls.push(info['url_friendly_name']);
           
            /*var reg=new RegExp("(%id%)", "g");
            
            for(var i=0; i<info['urls'].length; i++)
            {
              //urls.push(info['urls'][i].replace(reg,"" + _that._trackingId));
              urls.push(info['url_friendly_name']);
            }*/
            
            _that._domainMap[w['domainId']]['trackingUrls'] = urls;            
            
            if(_that._domainMap[w['domainId']]['trackingUrls'].length > 0)
            {
              _that._activateWindow(w);
            }
          },
          {
            '_this':           _that,
            'w':               w
          }
        );  
      }    
  }; 
//-------------------------------------------------------------- 
  _that._desactivateWindow     = function(w)
  {
    var req           = 
    {
      'action':       'desactivate_tracking',
      'args':         {}
    };
   
    w['callback'](req);
  }
//-------------------------------------------------------------- 
  _that.initWindow         = function(windowId)
  {
    var w = _that._windowManager.getWindowById(windowId);
    
    //Map the domain
      if(!_that._domainMap[w['domainId']])
      {
        _that._domainMap[w['domainId']] = 
        {
          'activated':      false,
          'trackingUrls':   [],
          'subDomains':     {}
        };
      }
      
      if(!_that._domainMap[w['domainId']]['subDomains'][w['subDomain']])
      {
        _that._domainMap[w['domainId']]['subDomains'][w['subDomain']] =
        {
          'activated': false
        };
      }
      
      
    ///////////////////////////  
    //React to windows that have just been activated
    if((_that._windowsToRedirect[windowId])&&(_that._windowsToRedirect[windowId] != ""))
    {
      _that._domainMap[w['domainId']]['activated'] = true;
      _that._domainMap[w['domainId']]['subDomains'][w['subDomain']]['activated'] = true;
      
      var req           = 
      {
        'action':       'after_tracking',
        'args':         
        {
          'url':        _that._windowsToRedirect[windowId]
        }
      };
   
      w['callback'](req);
      
      _that._windowsToRedirect[windowId] = "";
    } 
    ///////////////////////////  
    else
    {
         
      //If the tracking should be activated, launch a request
      if(_that._domainMap[w['domainId']]['activated'])
      {
        //////////////////
        if((!_that._windowsBeingActivated[w['id']])||(_that._windowsBeingActivated[w['id']] != w['domainId']))
        {
                _that._activateWindow(w);
        }
        
        if(!_that._domainMap[w['domainId']]['subDomains'][w['subDomain']]['activated'])
        {
            _that._domainMap[w['domainId']]['subDomains'][w['subDomain']]['activated'] = true;
            
        }
      }
    }
  };
//-------------------------------------------------------------- 
/////////////////////////// 
  _that.saveAfterTrackingUrl     = function(windowId, url)
  {
    _that._windowsToRedirect[windowId] = url;
  };
  
  _that.activateDomainPage     = function(domainId,winid)
  {
      if(!_that._windowsBeingActivated[winid])
      {
          _that._windowsBeingActivated[winid]=domainId;
      }  
  }
  
/////////////////////////// 
//--------------------------------------------------------------   
  _that.activateDomain     = function(domainId)
  {
    if(_that._domainMap[domainId])
    {
      // if(!_that._domainMap[domainId]['activated'])
      // {
          _that._domainMap[domainId]['activated'] = true;
          
          for(var subDomain in _that._domainMap[domainId]['subDomains'])
          {
            //if(!subDomain['activated'])
            //{
              subDomain['activated'] = true;
              
              ws = _that._windowManager.getWindowsBySubDomain(subDomain);
              
              //if((ws)&&(ws[0]))
              for(var i=0; i < ws.length; i++)
              {
              ////////////
                if((!_that._windowsBeingActivated[ws[i]['id']])||(_that._windowsBeingActivated[ws[i]['id']] != ws[i]['domainId']))
                {
                //////////
                  _that._activateWindow(ws[i]);
                //////////
                }
             /////////////
              }
           // }
      //    }
          
          var activatedDomainsJSON		= _that._configManager.getConfig()['activatedDomains'];
          
          var activatedDomains			= new Array();
          
          if((activatedDomainsJSON)&&(activatedDomainsJSON!=""))
          {
          	activatedDomains = JSON.parse(activatedDomainsJSON);
          }
          
          activatedDomains.push(domainId+"");
          _that._configManager.setConfig({'activatedDomains':JSON.stringify(activatedDomains)});
       }
    }
  };
//--------------------------------------------------------------   
  _that.isDomainActive     = function(domainId)
  {
    return ((_that._domainMap[domainId])&&(_that._domainMap[domainId]['activated']));
  };
//--------------------------------------------------------------   
  _that.setTrackingId     = function(trackingId)
  {
    _that._trackingId = trackingId;
  };
//--------------------------------------------------------------
  _that.getTrackingId     = function()
  {
    return _that._trackingId;
  };
//--------------------------------------------------------------   
  _that.reset             = function()
  {
    _that.setTrackingId(0);
    _that._domainMap = new Object();
    
    //////////////////
    _that._windowsBeingActivated = {};
    _that._windowsToRedirect = {};
    //////////////////
   
  };
//--------------------------------------------------------------   
  _that.desactivateAll    = function()
  {
    _that.reset();
    
    _that._configManager.setConfig({'activatedDomains':""});
    
    var ws = _that._windowManager.getAllWindows();
    
    if((ws)&&(ws[0]))
    {
      for(var i=0; i < ws.length; i++)
      {
        _that.initWindow(ws[i]['id']);
        _that._desactivateWindow(ws[i]);
      }
    }
  };
//--------------------------------------------------------------   
  _that.reActivateAll    = function()
  {
    var ws = _that._windowManager.getAllWindows();
    
    if((ws)&&(ws[0]))
    {
      for(var i=0; i < ws.length; i++)
      {
        if(_that.isDomainActive(ws[i]['domainId']))
        {
          _that._activateWindow(ws[i]);
        }
      }
    }
  };  
//--------------------------------------------------------------
      _that.setUpdatePeriod    = function(updatePeriod)
      {
      //DISABLED TEMPORARILY
      /*
        _that.updatePeriod   = updatePeriod;
        
        clearInterval(_that.timer);
       
        _that.timer				= setInterval
        (
          function()
          {
            _that.reActivateAll();
          },
          
          (_that.updatePeriod * 1000)
        );	
      */
      };
//--------------------------------------------------------------
//--------------------------------------------------------------

			//Set a timer to refresh the tracking periodically
      _that.setUpdatePeriod(_that.updatePeriod);
  
}

/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
/**
 * WindowManager
 * @constructor
 */
function WindowManager()
{
  var _that   = this;

  _that._mapByDomain          = new Object();
  _that._mapById              = new Object();
//--------------------------------------------------------------
//--------------------------------------------------------------  
  _that.addWindow             = function(id, domainId, subDomain, url)
  {
    //Create the new window's data structure
    var windowData = 
    {
      'id':                 id,
      'domainId':           domainId,
      'subDomain':          subDomain,
      'url':                url,
      'callback':           function(request)
      {
        navigatorAbstractionLayer.sendRequestToTab(this['id'], request);
      }
    };
  
    //Map by domain
    if(!_that._mapByDomain[domainId])
    {
      _that._mapByDomain[domainId] = new Object();
    }
    
    if(!_that._mapByDomain[domainId][subDomain])
    {
      _that._mapByDomain[domainId][subDomain] = new Object();
    }
    
    if(!_that._mapByDomain[domainId][subDomain][id])
    {
      _that._mapByDomain[domainId][subDomain][id] = windowData;
    }
    
    //Map by id
    if(!_that._mapById[id])
    {
      _that._mapById[id] = windowData;
    }
    
    return windowData;
  };
//--------------------------------------------------------------    
  _that.removeWindow          = function(id)
  {
    if(_that._mapById[id])
    {
      //Remove by domain
      if(_that._mapByDomain[_that._mapById[id]['domainId']][_that._mapById[id]['subDomain']][id])
      {
        delete _that._mapByDomain[_that._mapById[id]['domainId']][_that._mapById[id]['subDomain']][id];
      }
    
      //Remove by id
      delete _that._mapById[id];
    }
  };
//--------------------------------------------------------------       
  _that.updateWindowCallback   = function(id, callback)
  {
    if(_that._mapById[id])
    {
      _that._mapById[id]['callback'] = callback;
    }
  };
//--------------------------------------------------------------       
  _that.getWindowById          = function(id)
  {
    var res = null;
    
    if(_that._mapById[id])
    {
      return _that._mapById[id];
    }
    
    return res;
  };
//--------------------------------------------------------------       
  _that.getAllWindows          = function()
  {
    var res = new Array();
    
    for(var w in _that._mapById)
    {
      res.push(_that._mapById[w]);
    }
    
    return res;
  };
//--------------------------------------------------------------       
  _that.getWindowsByDomainId    = function(domainId)
  {
    var res = new Array();
    
    if(_that._mapByDomain[domainId])
    {
      for(var subDomain in _that._mapByDomain[domainId])
      {
        for(var windowData in _that._mapByDomain[domainId][subDomain])
        {
          res.push(_that._mapByDomain[domainId][subDomain][windowData]);
        }
      }
    }
    
    return res;
  };
//--------------------------------------------------------------       
  _that.getWindowsBySubDomain   = function(subDomain)
  {
    var res = new Array();
    
    for(var windowData in _that._mapById)
    {
      if(_that._mapById[windowData]['subDomain'] == subDomain)
      {
        res.push(_that._mapById[windowData]);
      }
    }
    
    return res;
  };
//--------------------------------------------------------------    
}
/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/

/**
 * CapitalKoalaExtension
 * @constructor
 */
function CapitalKoalaExtension()
{
  var _that = this;
  _that.adBlockShownOnce=false;
  _that.referrer_block     =    {};
  _that['currentTabUrl']={}; 
  _that.configManager	   = new ConfigManager();
  _that.eventManager     = new EventManager(_that);
  _that.activatedSiteIds = {};

  _that.database         = new Database("http://www.capitalkoala.com/api/program/","http://www.capitalkoala.com/api/referrer/", _that.configManager.getConfig()['ttl']);    

  _that.sessionManager   = new SessionManager
  (
    _that.configManager.getConfig()['ttl'],
    
    function (userInfo, args)     //onConnect
    {
      //Set the tracking id number
      _that.trackingManager.setTrackingId(userInfo['id']);
      
      //Update the menu
      _that.categoryMenu.setUserId(userInfo['id']);
      navigatorAbstractionLayer.notifyConnectionStateChange();
    },
    
    {
      '_this':    _that            //onConnectArgs
    },

    function (userInfo, args)     //onDisconnect
    {   
      _that.onDisconnect(); 
      navigatorAbstractionLayer.notifyConnectionStateChange();   
    },
    
    {
      '_this':    _that            //onDisconnectArgs
    }
  );  
  _that.windowManager    = new WindowManager();

  _that.trackingManager  = new TrackingManager(_that.windowManager, _that.database, _that.configManager, _that.configManager.getConfig()['ttl']);
  _that.toolbarManager   = new ToolbarManager(_that.windowManager, _that.trackingManager, _that.database, _that.configManager, _that.eventManager);
  _that.categoryMenu		= new CategoryMenuServer
	(
		"http://www.capitalkoala.com/api/category/", 
		"http://www.capitalkoala.com/api/program/", 
		_that.configManager.getConfig()['ttl']
	);  
	
  _that.connectionPopup   = null;
  _that.configPopup  	    = null;
  _that.tosPopup          = null;
  _that.adblockPopup      = null;
  _that.refwarningPopup      = null;  
  
  _that._onConnectedCallback     = null;
  _that._onConnectedCallbackArgs = null;
  
  //Initialize preActivated domains table
  //TODO: Insert in TrackingManager
  _that._preActivatedDomains		= new Object();
  
  //Generate the category menu with good user ids
    _that.sessionManager.isUserConnected
    (
      function(connected, args)
      {      
        if(connected)
        {
           _that.categoryMenu.setUserId(_that.sessionManager.getUserInfo()['id']);
           ///////////////////
           _that.trackingManager.setTrackingId(_that.sessionManager.getUserInfo()['id']);
           ///////////////////
           
           //If the user is connected, also load the pre-activated domains
       		var activatedDomainsJSON		= _that.configManager.getConfig()['activatedDomains'];
       		
       		if((activatedDomainsJSON)&&(activatedDomainsJSON != ""))
       		{
		   		   var activatedDomains		= JSON.parse(activatedDomainsJSON);

    				for(var i=0; i<activatedDomains.length; i++)
    				{
    					_that._preActivatedDomains[activatedDomains[i]]	= true;
    				}
    			}
        }
        else
        {
        	
           	_that.categoryMenu.setUserId(0);
           	///////////////////
           	_that.trackingManager.setTrackingId(0);
           	///////////////////
           	
           	//If the user isn't connected, flush the saved activatedDomains
           	_that.configManager.setConfig({'activatedDomains':""});
        }
      },
      
      {
        '_this': 	    _that
      }
    );
    
  //Update the local configuration   
    wget
    (
      "http://www.capitalkoala.com/api/toolbar/firefox/?time=" + (new Date().getTime()),
      
      function(response, args)
      {
        if((response)&&(response['preferences']))
        {
          var newTtl  = response['preferences']['tracking_ttl'];
          
          _that.database.ttl          = newTtl;
          _that.sessionManager.ttl    = newTtl;
          _that.categoryMenu.setUpdatePeriod(newTtl);
          _that.trackingManager.setUpdatePeriod(newTtl);
          
          //Save the new parameters
          _that.configManager.setConfig({'ttl':newTtl});
        }
      },
      
      {
        '_this':          _that
      }
    );

//--------------------------------------------------------------  
//-------------------------------------------------------------- 

 
  _that.onPreActivatedDomainPre     = function(windowId)
  {
    //1.Check if the user is connected
    _that.sessionManager.isUserConnected
    (
      function(connected, args)
      { 
        if(connected)
        {
          //2a. If yes, activate tracking and toolbar
          var w = _that.windowManager.getWindowById(args['windowId']);
          
          if(w)
          {
            _that.trackingManager.activateDomain(w['domainId']);

            //_that.toolbarManager.activateDomain(w['domainId']);

          }          
        }
      },
      
      {
        '_this':        _that,
        'windowId':     windowId
      }
    );
  };
//--------------------------------------------------------------  
  _that.onPreActivatedDomainPost     = function(windowId)
  {
    //1.Check if the user is connected
    _that.sessionManager.isUserConnected
    (
      function(connected, args)
      {
        
        if(connected)
        {
          //2a. If yes, activate tracking and toolbar
          var w = _that.windowManager.getWindowById(args['windowId']);
          
          if(w)
          {
            //_that.trackingManager.activateDomain(w['domainId']);

            _that.toolbarManager.activateDomain(w['domainId']);

          }          
        }
      },
      
      {
        '_this':        _that,
        'windowId':     windowId
      }
    );
  };
  
_that['blockAllReferrers']=function(hostname,winid)
{
    for (var key in _that.referrer_block[hostname])
    {
        if (_that.referrer_block[hostname][key] == undefined)
            _that.referrer_block[hostname][key] = {'block':true,'message':''};
        else
            _that.referrer_block[hostname][key]['block'] = true;
        
    }
     if (_that.referrer_block[hostname][winid+""] == undefined)
        _that.referrer_block[hostname][winid+""] = {'block':true,'message':''};
     else
        _that.referrer_block[hostname][winid+""]['block'] = true;    
    
}

_that['getReferrerBlock'] = function(windowId,domain,referrer,url)
{

    var tmp={'block':false,'message':''};
    return  {'samesite':false, 'block': tmp};
                
}


/*_that['getReferrerBlock'] = function(windowId,domain,referrer,url)
{
                    
               var refer=referrer;

                var winid=windowId;
          
                if (_that.referrer_block[domain] == undefined)
                    _that.referrer_block[domain]={}

                if (refer != "")                
                {

                    isCommerce=refer.indexOf("/aclk?")>0;

                    var ind=refer.indexOf("://");
                    if (ind>=0)
                        refer=refer.substring(ind+3);

                    ind=refer.indexOf("/");
                    if (ind>=0)
                        refer=refer.substring(0,ind);

                    if (domain==refer)
                    {
                        return {'samesite':true, 'block': _that.referrer_block[domain][winid+""]};                                    
                    }

                    var t = domain ;
			while (true)
			{
				var site_id = _that.database['_d']['domains'][t] ;
				if (site_id != undefined)
					break;
				if (t.indexOf(".") > -1)
					t = t.substr(t.indexOf(".")+1) ;
				else
					break;
			}                    
                    
                    var found=false;
                    
                   for (var j in _that.database['_d2']['referrers_list'])
                   {      
                        var reffound = _that.database['_d2']['referrers_list'][j];
                        if ( j=="Lien commercial Google" &&  !isCommerce)
                            continue;
                            
                        tab=reffound['urls'].split(',');                                               

                        for (k=0;k < tab.length && !found;k++)
                        {
                            var t=refer.toLowerCase();
                            while (true)
                            {
                                if (t.indexOf(tab[k].toLowerCase())==0)
                                {
                                    found=true;
                                    break;
                                }
                                if (t.indexOf(".") > -1)
					t = t.substr(t.indexOf(".")+1) ;
				else
					break;
                            }
                        }
                            
                        if (found)
                        {        

                            if (reffound['message']=="")
                                referrer_message=_that.database['_d2']['default_messages'][parseInt(reffound['type'])];
                            else
                                referrer_message=reffound['message'];  

                           program_ids = _that.database['_d']['sites'][site_id]["urls"];
                           pid = program_ids[0] ;
                           program =_that.database['_d']['programs'][pid];
                           _that['url_friendly_name']=CK_EXT_PARAMETERS.SITE_BASE_URL+"/redirection/marchand/"+program["url_friendly_name"] + '?toolbar=1';
                           

                           _that['notify_on_listed_referrer']=program["notify_on_listed_referrer"];
                           
                            if (reffound['block_all_domains']) 
                            {
                                _that['blockAllReferrers'](domain,windowId);
                                _that.referrer_block[domain][winid+""]={'block': true, 'message':referrer_message};
                                if (_that['notify_on_listed_referrer'])
                                    _that.displayRefWarningPopup(referrer_message==undefined?"":referrer_message.replace(/\r\n/gi,'<br>'),_that['url_friendly_name']);  
                                return  {'samesite':false, 'block': _that.referrer_block[domain][winid+""]};
                            }
                           

                                for (i = 0 ; i < program_ids.length ; i++)
                                {
                                        pid = program_ids[i] ;
                                        program = _that.database['_d']['programs'][pid];
                                        if (program["deactivate_on_listed_referrer"])
                                        {  
                                            _that['blockAllReferrers'](domain,windowId);
                                            _that.referrer_block[domain][winid+""]={'block': true, 'message':referrer_message};
                                            if (_that['notify_on_listed_referrer'])
                                                _that.displayRefWarningPopup(referrer_message==undefined?"":referrer_message.replace(/\r\n/gi,'<br>'),_that['url_friendly_name']);
                                            return  {'samesite':false, 'block': _that.referrer_block[domain][winid+""]};
                                        }
                                }
                                if (url!=_that['currentTabUrl'][winid+""])
                                    _that.referrer_block[domain][winid+""]={'block': false, 'message':""}; 
                            break;
                        }
                   }
                   if (!found)
                   {
                            if (url!=_that['currentTabUrl'][winid+""])
                                _that.referrer_block[domain][winid+""]={'block': false, 'message':""};                                          
        
                   }
                }
                else
                   {
                            if (url!=_that['currentTabUrl'][winid+""])
                                _that.referrer_block[domain][winid+""]={'block': false, 'message':""};                     
                   }
                return  {'samesite':false, 'block': _that.referrer_block[domain][winid+""]};
                
}*/

  _that.getWindowsByDomainId    = function(domainId)
  {
    var res = new Array();
    if(_that.windowManager._mapByDomain[domainId])
    {
      for(var subDomain in _that.windowManager._mapByDomain[domainId])
      {
        for(var windowData in _that.windowManager._mapByDomain[domainId][subDomain])
        {
          res.push(_that.windowManager._mapByDomain[domainId][subDomain][windowData]);
        }
      }
    }
    
    return res;
  };
  
  _that.isActivationAlone = function(hostname,winid)
  {
    if (_that.referrer_block[hostname]!=undefined && _that.referrer_block[hostname][winid+""]!=undefined && _that.referrer_block[hostname][winid+""]['block'])
    {
        for (var key in _that.referrer_block[hostname])
        {
            if (_that.referrer_block[hostname][key] != undefined && _that.referrer_block[hostname][key]['block'] && key!=winid)
                return true;
        }
    }
    return false;    
  }
  

  
//--------------------------------------------------------------   
  _that.initWindow                = function(windowId, windowSubDomain,windowUrl,referrer)
  {
    //-- If window already exists, delete it from the system --
    if(_that.windowManager.getWindowById(windowId))
    {
      _that.windowManager.removeWindow(windowId);
    }   
    
                     
  
    //1.Check if the window needs to be managed by the application
    _that.database.ifDomainIsConcerned
    (
      windowSubDomain,
      
      function(domainId, args)
      {
                
         //2. If yes, initialize the window
         var w=_that.windowManager.addWindow(args['windowId'], domainId, args['windowSubDomain'],windowUrl);

         var u=args["windowUrl"];
                 
         doblock=_that['getReferrerBlock'](windowId,windowSubDomain,referrer,u);
                   
        _that.trackingManager.initWindow(args['windowId']);

        if (_that.isActivationAlone(windowSubDomain,args['windowId']))
        {    
             _that.toolbarManager.initWindow(args['windowId'],doblock);
             _that.toolbarManager._activateWindow(w);
             w['toolbarState']['isReferrerBlock']=false;
        }
        else
        {
             //3. If the window points on a preactivated domain, activate it
             if(_that._preActivatedDomains[domainId + ""])
             {
                    _that.onPreActivatedDomainPre(args['windowId']);
             }

             //4. Finish initialization
             _that.toolbarManager.initWindow(args['windowId'],doblock);

             w['toolbarState']['isReferrerBlock']=false;

             //5. If the window points on a preactivated domain, activate it
             if(_that._preActivatedDomains[domainId + ""])
             {
                    _that.onPreActivatedDomainPost(args['windowId']);
                    delete _that._preActivatedDomains[domainId + ""];
             } 
        }
                        
                 
        _that['currentTabUrl'][windowId+""]=u;                 

      },
      
      {
        '_this':            _that,
        'windowId':         windowId,
        'windowSubDomain':  windowSubDomain,
        'windowUrl':  windowUrl        
      }
    );

  };

//-------------------------------------------------------------- 
  _that.displayConnectionPopup   = function(onConnectedCallback, callbackArgs, errorOn)
  {
    if(!_that.connectionPopup)
    { 
      _that._onConnectedCallback     = onConnectedCallback;
      _that._onConnectedCallbackArgs = callbackArgs;
            
      navigatorAbstractionLayer.openPopup
      (
        "connect", 
        600,
        360,
        errorOn, 
        function(w)
        {
          _that.connectionPopup = w;
        }
      );
    }
  };  
//-------------------------------------------------------------- 
  _that.hideConnectionPopup       = function()
  {
    if(_that.connectionPopup)
    {
      navigatorAbstractionLayer.hidePopupWithId
      (
        _that.connectionPopup['id'],
        function()
        {
          _that.connectionPopup = null;
        }
      );    
    }
  }
//-------------------------------------------------------------- 
  _that.displayPromoPopup   = function(windowId)
  {      
      var w 			= _that.windowManager.getWindowById(windowId);

      navigatorAbstractionLayer.openPromoPopup
      (
        _that,
        w['url'], 
        false, 
        function(w){}
      );
  };  
//-------------------------------------------------------------- 
  _that.displayConfigPopup   = function()
  {
    if(!_that.configPopup)
    {
      navigatorAbstractionLayer.openConfigPopup
      (
        _that,
        false,
        function(w)
        {          
          _that.configPopup = w;
        }
      );
    }
  };  
//-------------------------------------------------------------- 
  _that.hideConfigPopup       = function()
  {
    if(_that.configPopup)
    {
      navigatorAbstractionLayer.hidePopupWithId
      (
        _that.configPopup['id'],
        function()
        {
          _that.configPopup = null;
        }
      );    
    }
  }
//-------------------------------------------------------------- 
  _that.onActivationRequest        = function(windowId)
  {
    //1.Check if the user is connected
    _that.sessionManager.isUserConnected
    (
      function(connected, args)
      {        
        if(connected)
        {
            
          //2a. If yes, activate tracking and toolbar
          var w = _that.windowManager.getWindowById(args['windowId']);
          
          if(w)
          {
            //////////////////////////////////////
            // EVENT TRACKING
            //////////////////////////////////////
            navigatorAbstractionLayer.getUrlOfTab
            (
              w['id'],
              function(url)
              {
                _that.eventManager.sendToolbarTrackingLinkClickedEvent
                (
                  _that.trackingManager.getTrackingId(), 
                  w['domainId'],
                  url
                );
              }
            );
            
            var ws = _that.getWindowsByDomainId(w['domainId']);

            var doDomain=true;
            if((ws)&&(ws[0]))
            {
              for(var i=0; i < ws.length && doDomain; i++)
              {
                    if (ws[i]['toolbarState'] != undefined &&  ws[i]['toolbarState']['isReferrerBlock'])
                        doDomain=false;
              }
            }
            if (doDomain)
            {
                _that.trackingManager.activateDomain(w['domainId']);

                _that.toolbarManager.activateDomain(w['domainId']);
            }
            else
            {
                if((ws)&&(ws[0]))
                {
                  for(var i=0; i < ws.length; i++)
                  {
                    if (ws[i]['toolbarState'] != undefined &&  !ws[i]['toolbarState']['isReferrerBlock'])
                    {
                        _that.trackingManager._activateWindow(ws[i]);
                        _that.toolbarManager._activateWindow(ws[i]);
                    }
                  }
                }
            }                        
            
          }          
        }
        else
        {
          //2a. If no, display connection popup
          _that.displayConnectionPopup
          (
            //As a callback, re-process the request
            function(args)
            {    
              navigatorAbstractionLayer.openReferrerPopup
                  (
                    "Vous êtes désormais connecté(e) à Capital Koala.", 
                    "",
                    function(w)
                    {          
                      
                    }
                  );
              _that.onActivationRequest(args['windowId']);
            },
            
            {
              '_this':     _that,
              'windowId':  windowId
            },
            
            false
          );
        }
      },
      
      {
        '_this':        _that,
        'windowId':     windowId
      }
    );
  };
//-------------------------------------------------------------- 
  _that.isConnected        = function(callback)
  {
    //1.Check if the user is connected
    _that.sessionManager.isUserConnected
    (
      function(connected, args)
      {      
        if(connected)
        {
          //2 If yes, add domainId to the merchants listed in the data structure
          	var userInfo = _that.sessionManager.getUserInfo();
          
          	_that.database.update
          	(
          		function(args)
          		{
          			var userInfo	= args['userInfo'];
          			
                for(var i=0; i<userInfo['merchants'].length; i++)
                {
                  //FIXME: Calling private element
                  for(var program in _that.database['_d']['programs'])
                  {
                   // if(CK_EXT_PARAMETERS.SITE_BASE_URL+"/redirection/marchand/"+_that.database['_d']['programs'][program]['url_friendly_name'] == userInfo['merchants'][i]['url'])
                    if("http://www.capitalkoala.com/redirection/marchand/"+_that.database['_d']['programs'][program]['url_friendly_name']  == userInfo['merchants'][i]['url'])
                    {
                      if(_that.database['_d']['programs'][program]['domainId'])
                      {
                        userInfo['merchants'][i]['domainId'] = _that.database['_d']['programs'][program]['domainId'];
                      }
                    }
                  }
                }
                
                  //3. And call callback
                  args['callback'](userInfo);
                },
                {
                  '_this':      _that,
                  'userInfo':		userInfo,
                  'callback':		args['callback']
                }
          	);
        }
        else
        {
          args['callback'](null);
        }
      },
      
      {
        '_this': 	      _that,
        'callback':     callback
      }
    );
  };
//-------------------------------------------------------------- 
  _that.onConnectRequest        = function(login, password)
  {

//	chrome['windows']['create']();
    _that.sessionManager.connect
    (
      login, 
      password,
      
      function(connected, args)
      {
        //React upon success/failure of the connection
        if(connected)
        {
          //Success: Call the callback function
          if(_that._onConnectedCallback)
          {
            _that._onConnectedCallback(_that._onConnectedCallbackArgs);
            _that._onConnectedCallback     = null;
            _that._onConnectedCallbackArgs = null;
          }
          
          //...And save the login/password
          _that.configManager.setConfig({'login': login, 'password': password});
        }
        else
        {
          //Failure: Notify user
          _that.displayConnectionPopup(_that._onConnectedCallback, _that._onConnectedCallbackArgs, true);
        }
      },
      
      {
          '_this':      _that
      }
    );
  };
//--------------------------------------------------------------   
  _that.onDisconnect        = function()
  {
  	//Update the menu
    _that.categoryMenu.setUserId(0);
  
    //After a disconnection, we desactivate all tracking and toolbars
    _that.trackingManager.desactivateAll();
    _that.toolbarManager.desactivateAll();
    
    //We will also flush the preActivated domains
    _that._preActivatedDomains	= new Object();
  };
//--------------------------------------------------------------   
  _that.disconnectUser      = function()
  {
    _that.sessionManager.disconnect();
  };
//--------------------------------------------------------------   
  _that.getCategoryMenuDom  = function(callback)
  {
    callback(_that.categoryMenu.getData());
  };
//--------------------------------------------------------------   
  _that.getConfig  			= function(callback)
  {
    callback(_that.configManager.getConfig());
  };
//--------------------------------------------------------------   
  _that.setConfig  			= function(args)
  {
    _that.configManager.setConfig(args);
  };
//--------------------------------------------------------------   
  _that.getDomainInfo  		= function(callback, domainId)
  {
  	var info = _that.database.getDomainInfoById
  	(
  		domainId,
  		
  		function(info, args)
  		{
  			args['callback'](info);
  		},
  		
  		{
  			'callback':		callback,
                        'w': _that.windowManager.getWindowsByDomainId(domainId)[0]
  		}
  	);
  };
  
  _that.onActivateDomainPage	= function(domainId,winid)
  { 
    _that.trackingManager.activateDomainPage(domainId,winid);
  };
  
//--------------------------------------------------------------   
  _that.onPreActivateDomain	= function(domainId, url)
  { 
    //////////////////////////////////////
    // EVENT TRACKING
    //////////////////////////////////////
    _that.eventManager.sendOpenProgramUrlEvent
    (
      _that.trackingManager.getTrackingId(), 
      domainId,
      url
    );
    //////////////////////////////////////

  	if(!_that._preActivatedDomains[domainId + ""])
    {
      	_that._preActivatedDomains[domainId + ""] = true;
    }
  };
//--------------------------------------------------------------   
  _that.onConnectButtonClicked	= function(currentTabId)
  {  
		_that.onActivationRequest(currentTabId);
  };
//--------------------------------------------------------------   
  _that.checkVersion     = function()
  {
    //Check that we've got last version
    wget
    (
      "http://www.capitalkoala.com/project/public/media/toolbars/capitalkoala/sf/safari/index2.php?time=" + (new Date().getTime()),
      
      function(response, args)
      {
        if((response)&&(response['version']))
        {
          var newVersion  = response['version'];
        
          var localVersion = "3.0.0.6";//localStorage["CK_version"];

/***
          if((!localVersion)||(localVersion=='undefined'))
          {
            localStorage["CK_version"] = "3.0.0.6";
            localVersion                                            = "3.0.0.6";
          }
***/

          if(localVersion < response['version'])
          {
            navigatorAbstractionLayer.reactToVersionExpiration
            (
              response['version']
            );
          }
        }
      },
      null
    );
  };
//--------------------------------------------------------------   
  _that.onTosResponse  = function(response)
  {  
    _that.hideTosPopup();

    if(response)
    {
      _that.configManager.setConfig({'acceptedTos':true});      
    }
    else
    {
      alert("Vous devez accepter les Conditions Générales d'Utilisation du Bouton d'aide à l'achat Capital Koala.\nLe Bouton vient d'être désactivé.");
      //alert("Vous devez accepter les conditions d'utilisation pour utiliser le Bouton d'Aide à l'Achat Capital Koala\nLe Bouton d'Aide à l'Achat vient d'être désactivée.");
    }
  };
//-------------------------------------------------------------- 
  _that.displayTosPopup   = function()
  {
    if(!_that.tosPopup)
    {
      navigatorAbstractionLayer.openPopup
      (
        "tos", 
        600, 
        500, 
        false, 
        function(w)
        {          
          _that.tosPopup = w;
        }
      );
      navigatorAbstractionLayer.openNewTab("http://www.capitalkoala.com/info/toolbar_welcome/");
      
    }
  };
//-------------------------------------------------------------- 
  _that.displayAdBlockPopup   = function(force)
  {
    if((force || !_that.adBlockShownOnce) && !_that.adblockPopup)
    {
    _that.adBlockShownOnce=true;
      navigatorAbstractionLayer.openPopup
      (
        "adblock", 
        600, 
        340, 
        false, 
        function(w)
        {     
          _that.adblockPopup = w;
        }
      );
    }
  };
  
  _that.redirectToMerchant   = function()
  {
    navigatorAbstractionLayer.openUrlInActiveTab(_that['url_friendly_name']);
  }
  
  _that.displayRefWarningPopup   = function(message,u_f_name)
  {
    if(!_that.refwarningPopup)
    {   

        var lastUpdateReminder = '0';
        try
        {
            lastUpdateReminder = localStorage['extensions..lastreferrerpopup.reminder'] ;
        }
        catch (e)
        {}          
      if (lastUpdateReminder==undefined)
        lastUpdateReminder='0';
      var date = new Date ();
      var epoch = date.getTime() ;
      if (epoch - parseInt (lastUpdateReminder) > 6*3600*1000)
      {
                   localStorage['extensions..lastreferrerpopup.reminder']= epoch.toString();

                    
                  navigatorAbstractionLayer.openReferrerPopup
                  (
                    message, 
                    u_f_name,
                    function(w)
                    {          
                      _that.refwarningPopup = w;
                    }
                  );
      }
    }
  };  
//-------------------------------------------------------------- 
  _that.hideTosPopup       = function()
  {
    if(_that.tosPopup)
    {
      navigatorAbstractionLayer.hidePopupWithId
      (
        _that.tosPopup['id'],
        function()
        {
          _that.tosPopup = null;
        }
      );    
    }
  };
//-------------------------------------------------------------- 
  _that.hideAdBlockPopup       = function()
  {
    if(_that.adblockPopup)
    {
      navigatorAbstractionLayer.hidePopupWithId
      (
        _that.adblockPopup['id'],
        function()
        {
          _that.adblockPopup = null;
        }
      );    
    }
  };
  
  _that.hideRefWarningPopup       = function()
  {
    if(_that.refwarningPopup)
    {
      navigatorAbstractionLayer.hidePopupWithId
      (
        _that.refwarningPopup['id'],
        function()
        {
          _that.refwarningPopup = null;
        }
      );    
    }
  };  
//-------------------------------------------------------------- 
  _that.getToolbarGUID     = function()
  {
    var guid = _that.configManager.getConfig()['toolbarGUID'];

    if((!guid)||(guid.length == 0))
    {
      guid = navigatorAbstractionLayer.generateGuid();
      
      _that.configManager.setConfig
      (
        {
          "toolbarGUID":             guid
        }
      );
    }

    return guid;
  }
//--------------------------------------------------------------  
//--------------------------------------------------------------   

////////////////////////////////////////////////////////
// Ask for TOS acceptance
////////////////////////////////////////////////////////
if(_that.configManager.getConfig()['acceptedTos'] === false)
{
    _that.displayTosPopup();
}
////////////////////////////////////////////////////////
}
/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/

 
var myExtension = new CapitalKoalaExtension();

//Wire up the requests
function onRequest(request, sender, callback)
{
  if(sender['tab'])
  {
    if(request['action'] == 'init_me')
    { 
        if  (sender['tab']['index']>=0 || request['args']['host'].indexOf('www.google.fr')>=0)
        {
          myExtension.initWindow(sender['tab']['id'], request['args']['host'], request['args']['url'],request['args']['referrer']);
          callback(myExtension.database['_d']);
        }
    }
    else if(request['action'] == 'activate_clicked')
    {
      myExtension.onActivationRequest(sender['tab']['id']);
    }
    
    else if(request['action'] == 'display_promo_popup')
    {
      myExtension.displayPromoPopup(sender['tab']['id']);
    }   
    else if(request['action'] == 'is_toolbar_active')
    {
      myExtension.toolbarManager.isWindowActive(sender['tab']['id']);
    } 

    else if(request['action'] == 'save_after_tracking_url')
    {
      myExtension.trackingManager.saveAfterTrackingUrl(sender['tab']['id'], request['args']['url']);
    }  

  }

  if(request['action'] == 'connect') // Sent by Connection popup
  {
    myExtension.onConnectRequest(request['args']['login'], request['args']['password']);
  }
  
  else if(request['action'] == 'close_connection_popup')
  {
    myExtension.hideConnectionPopup();
  }
  
  else if(request['action'] == 'disconnect')
  {
    myExtension.disconnectUser();
  }
  
  else if(request['action'] == 'get_category_menu_dom')
  {
    myExtension.getCategoryMenuDom(callback);
  }
  
  else if(request['action'] == 'is_connected')
  {
    myExtension.isConnected(callback);
  }
  
  else if(request['action'] == 'get_config')
  {
    myExtension.getConfig(callback);
  }    
  
  else if(request['action'] == 'set_config')
  {
    myExtension.setConfig(request['args']);
  } 
  
  else if(request['action'] == 'display_config_popup')
  {
    myExtension.displayConfigPopup();
  }
  
  else if(request['action'] == 'close_config_popup')
  {
    myExtension.hideConfigPopup();
  }
  
  else if(request['action'] == 'get_domain_info')
  {
    myExtension.getDomainInfo(callback, request['args']['domainId']);
  }
  
  else if(request['action'] == 'pre_activate_domain')
  {
    myExtension.onPreActivateDomain(request['args']['domainId'], request['args']['url']);
  }
  else if(request['action'] == 'activate_domain_page')
  {
    myExtension.onActivateDomainPage(request['args']['domainId'],request['args']['winid']);
  }  

  else if(request['action'] == 'tos_response')
  {
    myExtension.onTosResponse(request['args']['accept']);
  }

  else if(request['action'] == 'close_tos_popup')
  {
    myExtension.hideTosPopup();
  }

  else if(request['action'] == 'display_tos_popup')
  {
    myExtension.displayTosPopup();
  }

  else if(request['action'] == 'close_adblock_popup')
  {
    myExtension.hideAdBlockPopup();
  }

  else if(request['action'] == 'display_adblock_popup')
  {
    myExtension.displayAdBlockPopup(request['args']['force']);
  }
  
  else if(request['action'] == 'close_refwarning_popup')
  {
    myExtension.hideRefWarningPopup();
  }

  else if(request['action'] == 'display_refwarning_popup')
  {
    myExtension.displayRefWarningPopup(request['args']['message'],myExtension["url_friendly_name"]);
  }  
  else if(request['action'] == 'redirect_to_merchant')
  {
    myExtension.redirectToMerchant();
  }  

  else if(request['action'] == 'get_toolbar_guid')
  {
    var guid = myExtension.getToolbarGUID();
    callback(guid);
  }
	else if(request['action'] == 'safari__open_tab')
	{
		var newTab  	= safari['application']['activeBrowserWindow']['openTab']();
                if (request['args']['domainId']!=undefined)
                {
                    var winid=__deprecated__navigator.tabIdManager.getTabId(newTab);

                    if(!myExtension.trackingManager._windowsBeingActivated[winid])
                    {
                        myExtension.trackingManager._windowsBeingActivated[winid]=request['args']['domainId'];
                    }  
                    //myExtension.onActivateDomainPage(domainId, );
                }
		newTab['url'] 	= request['args']['url'];
	}

	else if(request['action'] == 'safari__goto')
	{
		var newTab  	= safari['application']['activeBrowserWindow']['activeTab'];
		newTab['url']  	= request['args']['url'];                
	}

	else if((sender['tab'])&&(request['action'] == 'safari__connect_button_clicked'))
	{
		myExtension.onConnectButtonClicked(sender['tab']['id']);
	}

	else if(request['action'] == 'safari__get_popup_data')
	{
		myExtension.getCategoryMenuDom
		(
		    function(menuDom)
		    {
		      var m       = menuDom;
		      var myExt   = myExtension;
		      
		      myExt.isConnected
		      (
		        function(userInfo)
		        {
					var userId = 0;

					if(userInfo && userInfo['id'])
					{
						userId = userInfo['id'];
					}

					var safariMenuDom = m;


		          callback
		          (
		            {
		              'menuDom':    safariMenuDom,
		              'userInfo':   userInfo,
		              'config':     myExt.configManager.getConfig()
		            }
		          );
		        }
		      );
		    }
		);
	}

	else if(request['action'] == 'safari__hide_popup')
	{
		callback();
	}

	else if(request['action'] == 'safari__hide_connect_popup')
	{
		callback();
	}

	else if(request['action'] == 'safari__hide_config_popup')
	{
		callback();
	}

	else if(request['action'] == 'safari__hide_promo_popup')
	{
		callback();
	}

	  else if(request['action'] == 'safari__check_version')
	{
		myExtension.checkVersion();
	}

	else if(request['action'] == 'safari__hide_version_popup')
	{
		callback();
	}

	else if(request['action'] == 'safari__hide_tos_popup')
	{
		callback();
	}

	else if(request['action'] == 'safari__hide_adblock_popup')
	{
		callback();
	}
	else if(request['action'] == 'safari__hide_refwarning_popup')
	{
		callback();
	}
	/////////////////////////////////////////////////////////////////////////////////
}

///////////////////////////////////////////////////////////////////////////////////
// SAFARI EXCLUSIVE
///////////////////////////////////////////////////////////////////////////////////
function safari__onRequest(event)
{
  var safari__event = event;

  var name 			= event['name'];
  var guidSuffix	= "";

  //Extract GUID when it is given
  if(event['name'].indexOf("/") > -1)
  {
  	var split 		= event['name'].split("/");
  	name 			= split[0];
  	guidSuffix		= "/" + split[1];
  }

  var request = 
  {
    'action':name,
    'args':event['message']
  };

  var sender = 
  {
    'tab':
    {
      'id':__deprecated__navigator.tabIdManager.getTabId(event['target'])
    }
  };

  onRequest(request, sender, function(args) {safari__event['target']['page']['dispatchMessage'](name + "_callback"+guidSuffix, args);});
}

function safari__onCommand(event)
{
    if (event['command'] === "capital_koala_icon_clicked") 
    {
    	var request =
		{
			'action':     "open_menu_popup",
			'args':       {}
		};
                
      	__deprecated__navigator.sendRequestToActiveTab(request);
    }
}

safari['application']['addEventListener']("message",safari__onRequest,false);
safari['application']['addEventListener']("command",safari__onCommand,false);
///////////////////////////////////////////////////////////////////////////////////