/******************************************************
 * Copyright eNoe 2011 - All rights reserved *
 * Author: Séverin MARCOMBES                          *
 ******************************************************/
 
//#################################################
// Useful functions
//#################################################
function wget(url, callback, callbackArgs)
{
  try
  {
    var request = new XMLHttpRequest();
    
    request.open('GET', url, true); //TODO: Add a parameter behind the URL to avoid cache effects
    request.onreadystatechange = function()
    {
      if(request.readyState == 4)
      {
        if(request.status==200)
        {
          var response = null;
          
          try
          {
            response = JSON.parse(request.responseText);
          }
          catch(exc)
          {}
        
          callback(
          response, 
          callbackArgs);
        }
        else if(request.status==0)
        {
          callback(null,callbackArgs);
        }
      }
    };

    request.send(null);
      
  }
  catch(exc)
  {}
}
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
